//: SimpleQueryBeanInfo.java

import java.beans.*;
import java.lang.reflect.*;
import java.awt.*;

public class SimpleQueryBeanInfo extends SimpleBeanInfo {

    /** Return an icon for the bean */
    public Image getIcon(int kind) {
        return null;
    }

    /** Return a descriptor for the bean.  */
    public BeanDescriptor getBeanDescriptor() {
        return new BeanDescriptor(SimpleQuery.class,
                                  SimpleQueryCustomizer.class);
    }

    /** This is a convenience routine for creating PropertyDescriptor objects,
      * called by the getPropertyDescriptors() method that follows.
      */
    public static PropertyDescriptor property(String name, String description)
                                    throws IntrospectionException {
        PropertyDescriptor p = new PropertyDescriptor(name, SimpleQuery.class);
        p.setShortDescription(description);
        return p;
    }

    public PropertyDescriptor[] getPropertyDescriptors() {
        try {
            PropertyDescriptor[] props = {
                property("openDatabase", "Indicates that bean is responsible for opening database"),
                property("remoteDatabase","Indicates that database will be accessed via RMI"),
                property("openDataset","Indicates that bean is responsible for opening dataset"),
                property("displayEntries","Indicates that bean should display retrieved data"),
                property("basename","The name of the database to be opened"),
                property("db","The database from which to retrieve data"),
                property("remoteHost","The host on which the database resides"),
                property("password","Password to be used in opening database"),
                property("ds","The dataset from which to retrieve data"),
                property("entries","An array containing returned data (not in use!)"),
                property("itemList","The items to retrieve (not in use, @ retrieved)"),
                property("keyName","The key name for non-serial reads (unused)"),
                property("keyValue","The key value for non-serial reads (unused)")
            };
            return props;
        } catch (IntrospectionException e) { return super.getPropertyDescriptors(); }
    }

    public int getDefaultPropertyIndex() { return -1; }

    /** Convenience method for creating MethodDescriptors */
    public static MethodDescriptor method(String name, String description)
                                    throws NoSuchMethodException, SecurityException {
       Method m = SimpleQuery.class.getMethod(name, new Class[] {} );
       MethodDescriptor md = new MethodDescriptor(m);
       md.setShortDescription(description);
       return md;
    }

    public MethodDescriptor[] getMethodDescriptors() {
        try {
            MethodDescriptor[] methods = {
                method("execute", "Execute the Query")
            };
            return methods;
        } catch (Exception e) {
            return super.getMethodDescriptors();
        }
    }


}
