//: SimpleQueryCustomizer.java
//  Updated for Swing 1.0.1 / JFC 1.1

import com.sun.java.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.beans.*;

import SimpleQuery;
public class SimpleQueryCustomizer extends java.awt.Panel
                                    implements Customizer /* , TextListener */ {

   private final String na = new String("Feature not yet implemented.");
   protected SimpleQuery bean;

   public SimpleQueryCustomizer() { 
     super(); 
      // following lines so Visual Cafe will use this customizer
      //{{INIT_CONTROLS
		setLayout(new FlowLayout(FlowLayout.CENTER,5,5));
		setSize(640,514);
		//}}
        
   }

   public void setObject(Object o) {
      bean = (SimpleQuery)o;
      customize();
   }
   
   protected PropertyChangeSupport listeners = new PropertyChangeSupport(this);
   
   public void addPropertyChangeListener(PropertyChangeListener p) {
      listeners.addPropertyChangeListener(p);
   }
   
   public void removePropertyChangeListener(PropertyChangeListener p) {
      listeners.removePropertyChangeListener(p);
   }

   public void customize() {
      JTabbedPane tabs = new JTabbedPane();
      tabs.addTab("Database Access", null, new AccessPanel() );
      tabs.addTab("Data Retrieval", null, new RetrievalPanel() );
      tabs.addTab("Filter Data", null, new FilterPanel() );
      tabs.addTab("Sort", null, new SortPanel() );
      tabs.addTab("Format Output", null, new FormatPanel() );
      tabs.setSelectedIndex(0);
      this.setLayout(new BorderLayout() );
      this.add(tabs, "Center");
   }

   public class AccessPanel extends JPanel {
      AccessPanel() {
        // Non-graphical components
        ButtonGroup bgOpenDB = new ButtonGroup();
        ButtonGroup bgOpenDS = new ButtonGroup();
        ButtonGroup bgRemote = new ButtonGroup();

        // Layout the panel, working top-to-bottom
        Box boxOpen = Box.createVerticalBox();
        JRadioButton bOpenDB = new JRadioButton("SimpleQuery must open database");
        JRadioButton bPassDB = new JRadioButton("A database reference will be passed in");
        // Add these buttons to the Button Group
        bgOpenDB.add(bOpenDB);
        bgOpenDB.add(bPassDB);
        // And also add them to the Box
        //boxOpen.setSize(300,75);
        //boxOpen.add(Box.createGlue());
        boxOpen.add(bOpenDB,"West");
        //boxOpen.add(Box.createGlue());
        boxOpen.add(bPassDB,"West");
        //boxOpen.add(Box.createGlue());
        // Now make some labels for the name and password
        JLabel l1 = new JLabel("  Database Name: ");
        JLabel l2 = new JLabel("  Database Password: ");
        // And text fields to follow the labels
        JTextField t1 = new JTextField(10);
        JTextField t2 = new JTextField(5);
        Box boxDBname = Box.createHorizontalBox();
        //boxDBname.setSize(400,20);
        boxDBname.add(l1);
        boxDBname.add(t1);
        Box boxPass   = Box.createHorizontalBox();
        //boxPass.setSize(400,20);
        boxPass.add(l2);
        boxPass.add(t2);
        Box boxNames = Box.createVerticalBox();
        //boxNames.setSize(400,50);
        boxNames.add(boxDBname);
        boxNames.add(boxPass);
        // Arrange the boxes in a pane with a grooved border (title?)
        JPanel bpOpenDB = new JPanel();
        bpOpenDB.setBorder(
                 BorderFactory.createTitledBorder(BorderFactory.createEtchedBorder(),
                 "Database"));
        Box box3 = Box.createVerticalBox();
        box3.setSize(400,300);  // if removed, contents will disappear!
        box3.add(boxOpen);
        box3.add(boxNames);
        bpOpenDB.setSize(400,100);
        bpOpenDB.add(box3);

        // Now handle the local/remote question
        JRadioButton bLocalDB = new JRadioButton("Database is local");
        JRadioButton bRemoteDB = new JRadioButton("Database is remote");
        bgRemote.add(bLocalDB);
        bgRemote.add(bRemoteDB);
        JLabel lHost = new JLabel("  Host name: ");
        JTextField tHost = new JTextField(10);
        Box bHost = Box.createHorizontalBox();
        bHost.add(lHost);
        bHost.add(tHost);
        Box b4 = Box.createVerticalBox();
        b4.setSize(400,300);
        b4.add(bLocalDB);
        b4.add(bRemoteDB);
        b4.add(bHost);
        JPanel bpLocal = new JPanel();
        bpLocal.setBorder(
                BorderFactory.createTitledBorder(BorderFactory.createEtchedBorder(),
                "Local or Remote Database"));
        bpLocal.setSize(400,100);
        bpLocal.add(b4);

        // See if we need to create the Dataset object
        JRadioButton bOpenDS = new JRadioButton("SimpleQuery must open dataset");
        JRadioButton bPassDS = new JRadioButton("A dataset reference will be passed in");
        bgOpenDS.add(bOpenDS);
        bgOpenDS.add(bPassDS);
        JLabel l3 = new JLabel("  Dataset Name: ");
        JTextField t3 = new JTextField(10);
        Box b5 = Box.createHorizontalBox();
        b5.add(l3);
        b5.add(t3);
        Box b6 = Box.createVerticalBox();
        b6.setSize(400,300);
        b6.add(bOpenDS);
        b6.add(bPassDS);
        b6.add(b5);
        JPanel bpOpenDS = new JPanel();
        bpOpenDS.setBorder(
                BorderFactory.createTitledBorder(BorderFactory.createEtchedBorder(),
                "Dataset"));
        bpOpenDS.setSize(400,150);
        bpOpenDS.add(b6);

        Box b7 = Box.createVerticalBox();
        b7.add(bpOpenDB);
        b7.add(bpLocal);
        b7.add(bpOpenDS);

        this.setLayout(new BorderLayout() );
        this.add(b7);
      }
   }
   public class RetrievalPanel extends JPanel {
      RetrievalPanel() {
        JRadioButton bSF = new JRadioButton("Forward Serial Read");
        JRadioButton bSB = new JRadioButton("Backward Serial Read");
        ButtonGroup bRead = new ButtonGroup();
        bRead.add(bSF);
        bRead.add(bSB);
        JPanel pMethod = new JPanel();
        pMethod.setSize(400,100);
        pMethod.setBorder(
                BorderFactory.createTitledBorder(BorderFactory.createEtchedBorder(),
                "Select Retrieval Method"));
        pMethod.add(bSF);
        pMethod.add(bSB);

        String[] items = { "EMPLOYEE-NUMBER",
                           "SOCIAL-SECURITY",
                           "FIRST-NAME",
                           "LAST-NAME",
                           "ADDRESS-1",
                           "ADDRESS-2",
                           "CITY",
                           "STATE",
                           "ZIP",
                           "PHONE" };

        JList jlbItems = new JList(items);
        JPanel pItems = new JPanel();
        pItems.setSize(400,100);
        pItems.setBorder(
                BorderFactory.createTitledBorder(BorderFactory.createEtchedBorder(),
                "Select items to be retrieved"));
        pItems.add(jlbItems);

        //Box b3 = Box.createVerticalBox();
        //b3.setSize(400,200);
        //b3.add(pMethod);
        //b3.add(pItems);
        //this.add(b3);
        this.setLayout(new BorderLayout() );
        this.add(pMethod,"North");
        this.add(pItems,"Center");
      }
   }
   public class FilterPanel extends JPanel {
      FilterPanel() {
        JLabel label = new JLabel(na, SwingConstants.CENTER);
        this.setLayout(new BorderLayout() );
        this.add(label, "Center");
      }
   }
   public class SortPanel extends JPanel {
      SortPanel() {
        JLabel label = new JLabel(na, SwingConstants.CENTER);
        this.setLayout(new BorderLayout() );
        this.add(label, "Center");
      }
   }
   public class FormatPanel extends JPanel {
      FormatPanel() {
        JLabel label = new JLabel(na, SwingConstants.CENTER);
        this.setLayout(new BorderLayout() );
        this.add(label, "Center");
      }
   }

   public static void main(String[] argv) {
      JFrame frame = new JFrame("SimpleQuery Customizer");
      frame.addWindowListener(new WindowAdapter() {
        public void windowClosing(WindowEvent e) { System.exit(0); }
      });

      SimpleQueryCustomizer bc = new SimpleQueryCustomizer();
      bc.customize();
      frame.getContentPane().setLayout(new BorderLayout());
      frame.getContentPane().add(bc, "Center");
      frame.setSize(500,400); // was 500,350
      frame.show();
   }
	//{{DECLARE_CONTROLS
	//}}
}


