//: IntrClient.java

import com.hp.turboimage.*;
import java.io.*;
import java.net.*;

/** This class provides an example of how to call the 
 *  Java TurboIMAGE library routines.  This class will open
 *  a database and read a dataset serially, displaying each 
 *  record.  At this point, only those functions required to
 *  support this program are actually implemented by the
 *  TurboIMAGE library.<p>
 *
 * @author Mike Yawn
 * @version prerelease, October 1996
 */
public class IntrClient {

   public static void main(String argv[]) throws IMAGEException {

      DBStatus status = new DBStatus();
      String basename = "  EMPDB.IMAGE.JAVA;";
      byte[]   base = basename.getBytes();
      String   password = "PASSWORD;"; 
      String   dataset = "EMPDTL;";
      String   list    = "EMPLOYEE-NUMBER,FIRST-NAME,LAST-NAME;";
      String   dummy = " "; // dummy parameter
      byte[]   buffer = new byte[1024];

      try {
         // Open a database
         DatabaseImpl.DBOPEN(base, password, 5, status);
                           
         // Read the dataset and display results 
         do {
            DatasetImpl.DBGET(base, dataset, 2, status, list, buffer, dummy);
            System.out.println(new String(buffer));
         } while (status.getStatus() == 0);
         System.out.println("No more entries in dataset.");
      } catch (Exception e2) {
         System.out.println(e2.toString());
      } finally {
         DatabaseImpl.DBCLOSE(base, dataset, 1, status);
      }
   }
}
