//: RMIClient.java

import com.hp.turboimage.*;
import java.rmi.*;

public class RMIClient {

   public static void main(String argv[]) {
      String hostname = "belle.cup.hp.com";
      String factory  = "TurboIMAGEFactory";
     
      // Set up logging
      //java.util.Properties p;
      //p = System.getProperties();
      //p.put("sun.rmi.transport.tcp.logLevel","verbose");
      //p.put("sun.rmi.transport.logLevel","verbose");
      //p.put("sun.rmi.server.logLevel","verbose");
      //System.setProperties(p);

      // Start the security manager
      System.setSecurityManager(new RMISecurityManager());

      try {
         // Connect to the remote factory
         TurboIMAGEServer dbfactory = (TurboIMAGEServer) Naming.lookup( 
              "rmi://" + hostname + "/" + factory);
System.out.println("Connected to server.");
 
         // Create a database object and open the database
         Database remoteDB = dbfactory.getDatabase("EMPDB.IMAGE.JAVA");
         remoteDB.setPassword("PASSWORD");
         remoteDB.openSharedRead();
System.out.println("Database is open.");

         // Create a Dataset
         Dataset remoteDS = dbfactory.getDataset(remoteDB, "EMPDTL");
System.out.println("Dataset created.");
         
         //Create an Entry for the dataset 
         Entry detailEntry = dbfactory.getEntry(remoteDB, remoteDS);
System.out.println("Entry created.");
         detailEntry.allElements();
System.out.println("Entry initialized.");

         // Read the dataset and display results 
         while(remoteDS.readSerial(detailEntry)){
            System.out.println(detailEntry.getValue("EMPLOYEE-NUMBER") 
               + " " + detailEntry.getValue("FIRST-NAME")
               + " " + detailEntry.getValue("LAST-NAME")       );
         }
         System.out.println("No more entries in dataset.");
      } catch (Exception e) {
         e.printStackTrace();
      }
   }

}
